QGIS Application - Bug report #18747
QGIS Server GetPrint issue on Desktop Linux installations
2018-04-18 01:18 PM - Giovanni Manghi

Status: Rejected

Priority: Low

Assignee:

Category: QGIS Server

Affected QGIS version:2.18.18 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution: wontfix
Crashes QGIS or corrupls data: Copied to github as #: 26634
Description

This may or may not be related to #15440
At some point in 2.18 development it seems that QGIS Server, in the context of GetPrint requests of layout composers with elements like
html text boxes, stopped to accept the standard DISPLAY from X11 causing the same symptoms (QGIS Server crash) as described in the

#15440 ticket.

This is a low priority issue as anyway under Linux there is a clear "workaround", install a fake xserver, for what in reality should not be a
real use case (a Desktop linux installation for a server).

To be tested under QGIS Server 3.

Related issues:
Related to QGIS Application - Bug report # 15440: QGIS Server: GetPrint cras... Closed 2016-08-15

History

#1 - 2018-04-18 02:18 PM - Jiirgen Fischer
- Description updated

#2 - 2018-04-18 02:18 PM - Juirgen Fischer

- Related to Bug report #15440: QGIS Server: GetPrint crashes on Windows when there are advanced elements (i.e. html text boxes) in the layout
being printed added

#3 - 2018-04-19 02:28 PM - Alessandro Pasotti

- Status changed from Open to Rejected

- Resolution set to wontfix

| cannot reproduce on 2.18 if running the server with my current user inside an xterm.

Btw I'd be surprised if it was working before: in order to not crash with HTML texts an X server is needed (fake or real) AND must be accessible by the
client user, that implies that if you are running the server under the same user that has access to DISPLAY (normally = ":0" ) everthing works fine but if you
try to run the server from a user (e.g. www-data) that has no authority to access to the DISPLAY it will fail.

Bottom line is: xvfb has always been required to run the server outside a graphical terminal shell (which would be nonsense for a server application).

Yuo can also test after "xhost +" and passing DISPLAY=:0 from a www-data termninal and it will work (because now it has authority to access X)

#4 - 2018-04-19 03:59 PM - Giovanni Manghi
Alessandro Pasotti wrote:

I cannot reproduce on 2.18 if running the server with my current user inside an xterm.

Btw I'd be surprised if it was working before: in order to not crash with HTML texts an X server is needed (fake or real) AND must be accessible by
the client user, that implies that if you are running the server under the same user that has access to DISPLAY (normally = ":0" ) everthing works fine

but if you try to run the server from a user (e.g. www-data) that has no authority to access to the DISPLAY it will fail.

Bottom line is: xvfb has always been required to run the server outside a graphical terminal shell (which would be nonsense for a server

application).

Yuo can also test after "xhost +" and passing DISPLAY=:0 from a www-data termninal and it will work (because now it has authority to access X)

| have just tested on a VM (Ubuntu Desktop 12.04 installed from scratch) and GetPrint works without needing to install xvfb (the package is not installed).
Or maybe it could another fake xserver that could be installed by default on older Ubuntu distributions? Any hint about what | should look for?
#5 - 2018-04-19 04:01 PM - Giovanni Manghi

I have just tested on a VM (Ubuntu Desktop 12.04 installed from scratch) and GetPrint works without needing to install xvfb (the package is not

installed). Or maybe it could another fake xserver that could be installed by default on older Ubuntu distributions? Any hint about what | should look

for?

forgot to mention: qgis server 2.8

#6 - 2018-04-20 02:32 AM - Giovanni Manghi

Giovanni Manghi wrote:
I have just tested on a VM (Ubuntu Desktop 12.04 installed from scratch) and GetPrint works without needing to install xvfb (the package is not
installed). Or maybe it could another fake xserver that could be installed by default on older Ubuntu distributions? Any hint about what | should

look for?

forgot to mention: qgis server 2.8

| tried also on Ubuntu 14.04 Desktop and QGIS 2.14, same result. No fake x server (not xvfb at least) and getprint works.

#7 - 2018-04-20 05:35 PM - Giovanni Manghi

| finally was able to test QGIS Server (master) on a Desktop Ubuntu installation, and this "issue" is not anymore. Much like for Windows:

https://issues.qgis.org/issues/15440#note-39

So... | agree that this in Linux/2.18 is not a problem (install the fake xserver) but | still wonder about the coincidence that this "affects" also QGIS Server

2.18 on Windows, where there is no solution.

#8 - 2018-04-24 02:28 PM - Uros Preloznik

2024-03-20 2/5


https://issues.qgis.org/issues/15440#note-39

Please don't leave this issue as fixed already. We need full instructions on DISPLAY variable and fake xserver, because | and believe many other users

have no idea what we are talking about here.

| have multiple QGIS Server setups on Windows and Linux (Ubuntu server, Linux Mint, Ubuntu desktop) and this issues is on all this setups on 2.18.
Printing was working on same setups on 2.14 and stopped working on 2.18, no other changes.

This should be high priority issue for 2.18 which should be stable but has this problem entire time as LTR release. If there is quick fix, please

describe it, when | tried adding DISPLAY variable QGIS Server stopped on GetMap...

#9 - 2018-04-24 10:55 PM - Uros Preloznik

Also, | can't really understand why | can print PDF with map, legend and scale and if | want to print simple text box that says "Hi", then | need to install

whole bunch of stuff like full desktop server and so on. Not that it's working on desktop, because it doesn't.

#10 - 2018-05-16 09:54 AM - Alessandro Pasotti

This is a longstanding issue and there is no solution other than install fakex on Linux/Unix systems.

AFAIK this is documented in the official QGIS Server documentation.

As far as windows is concerned, (my personal considerations here) I'm not a windows developer and | would not advice installing QGIS Server on other
platforms than Linux.

If it was my choice | would not even include Windows in the supported platforms for QGIS server.

#11 - 2018-05-16 10:17 AM - Uros Preloznik

Alessandro Pasotti wrote:

This is a longstanding issue and there is no solution other than install fakex on Linux/Unix systems.

AFAIK this is documented in the official QGIS Server documentation.

As far as windows is concerned, (my personal considerations here) I'm not a windows developer and | would not advice installing QGIS Server on

other platforms than Linux.

If it was my choice | would not even include Windows in the supported platforms for QGIS server.

Thanks for looking into this. | agree that maybe Windows setup is just not working well enough to support it. | see there is a lot of interest in community for
Windows setup, so | will add some note about that in this posts level2.si/2015/12/qgis-server-on-windows-10 and
http://level2.si/2018/03/ggis-server-3-0-on-windows-10/

As for documentation on fake X-server | found only this about DISPLAY variable
https://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/server/config.htmi#id2 and your post (couple of years old, though). Is there anything

else?

#12 - 2018-05-16 04:31 PM - Harrissou Santanna
http://level2.si/2018/03/qgis-server-3-0-on-windows-10/
https://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/server/config.html#id2

As for documentation on fake X-server | found only this about DISPLAY variable

https://docs.qqis.org/2.18/en/docs/user_manual/working_with_ogc/server/config.html#id2 and your post (couple of years old, though). Is there

anything else?

https://docs.qgis.org/testing/en/docs/user_manual/working_with_ogc/server/getting_started.html#xvfb maybe?

#13 - 2018-05-18 02:47 PM - Uros Preloznik

Harrissou Santanna wrote:

As for documentation on fake X-server | found only this about DISPLAY variable
https.//docs.qgis.org/2.18/en/docs/user_manual/working with_ogc/server/config.htmi#id2 and your post (couple of years old, though). Is there

anything else?

https://docs.qqis.org/testing/en/docs/user_manual/working_with_ogc/server/getting_started.html#xvfb maybe ?

Thank you, | will go through that. | was looking only in 2.18 documentation and not testing docs. One thing | still don't understand is why do | need this if I'm

running QGIS Server on Ubuntu Desktop or Linux Mint with GUI. | understand it is needed for only server setups without GUI.

#14 - 2018-05-18 02:50 PM - Giovanni Manghi

Uro$ Preloznik wrote:

| understand it is needed for only server setups without GUI.

No, in QGIS 2.18 it is necessary also on Desktop installations (it wasn't necessary on 2.14 and is not necessary on 3). This is something that has changed

at some point during the 2.18 development as the first point releases of 2.18 were not affected. | proved/tested this several times.

#15 - 2018-05-18 03:50 PM - Giovanni Manghi

Giovanni Manghi wrote:

Uros PrelozZnik wrote:

| understand it is needed for only server setups without GUI.

No, in QGIS 2.18 it is necessary also on Desktop installations (it wasn't necessary on 2.14 and is not necessary on 3). This is something that has

changed at some point during the 2.18 development as the first point releases of 2.18 were not affected. | proved/tested this several times.

note: this #15440-23 seems to point to a packing issue rather than a bug (as when compiling the source code this problem does not seems to happen, only

when using packages from repositories).

#16 - 2018-07-23 10:19 AM - Uros Preloznik

Hi,

2024-03-20 4/5


https://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/server/config.html#id2
https://docs.qgis.org/2.18/en/docs/user_manual/working_with_ogc/server/config.html#id2
Tested this issue with QGIS Server 3.2 on Ubuntu 18.04. It's working normally out of the box, no need to setup XVFB.

Now, documentation should be fixed, that this chapter

https://docs.qgis.org/testing/en/docs/user_manual/working_with_ogc/server/getting_started.html#xvfb

goes to 2.18 docs and is removed from testing (3.x) docs.

Is it OK to do that, is XVFB used anywhere else?

How exactly fix documentation like this?

Uro$
